package besysMonitor;

public class ProdConsBuffer {
    private final int capacity = 10; 
    private final int[] buffer = new int[capacity]; 
    private int count = 0;
    private int low = 0;
    private int high = 0; 
	
    public ProdConsBuffer(int initialFill){
	if ((initialFill > 0) && (initialFill < capacity)){
	    for (int i = 0; i < initialFill; i++){
		buffer[i] = i;
	    }
	    high = initialFill;
	    count = initialFill;
	}
    }

    public synchronized void insert(int value){
	while (count == capacity){
	    gotoSleep();
	}
	buffer[high] = value;
	++count;
	high = ++high % capacity; 
	if (count == 1){
	    notify(); 
	}
	printMsg( "added", value, count);
	return; 
    }
	
    public synchronized int getItem(){
	int value;
	while (count == 0){
	    gotoSleep();
	}
	value = buffer[low];
	--count;
	low = ++low % capacity;
	if (count == capacity - 1){
	    notify();
	}
	printMsg( "   removed", value, count);
	return value; 
		
    }
	
    private void gotoSleep(){
	try{
	    wait();
	}
	catch(InterruptedException ex){
	    ex.printStackTrace(); 
	}
    }
   
    private void printMsg(String start, int value, int count){
	System.out.print(start + " value: " + Integer.toString(value));
	System.out.println(" count: " + Integer.toString(count));
    }   	
}
