
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h> 
#include <sys/wait.h> 

typedef char * CHAR_PTR;

void childFunction(){
  int i = 0; 
  int sleepVal;
  char command[] = "/bin/ps";
  char comdName[] = "name-ps";  
  char option[] = "-el"; 
  CHAR_PTR argv[3];  

  char logFileName[] = "child.log";
  FILE *logFile;

  logFile = fopen(logFileName, "wt");
  if (logFile == NULL){
    printf("\n P: could not open file: %s", logFileName);
  }
  fputs("\n ---- \n running child function \n", logFile);
  while (i < 10){
    sleepVal = sleep(2);
    fprintf(logFile, "%3d", i);
    fflush(logFile);
    i++;
  }
  /* calling program ps with option -el  */ 
  argv[0] = comdName;
  argv[1] = option;
  argv[2] = NULL; 
  execvp(command, argv); 

  /* unreachable code: 
    fputs("\n end of child process \n", logFile);
    fflush(logFile);
    exit(0);
  */
}




void parentFunction(FILE * logFile, pid_t pid){
  int i = 0; 
  int sleepVal;
  pid_t waitVal;

  fputs("\n running parent function \n", logFile);

  while (i < 10){
    sleepVal = sleep(1);
    fprintf(logFile, " %3d", i);
    fflush(logFile);
    i++;
  }
  fputs("\n waiting for child \n", logFile);
  fflush(logFile);
  waitVal = waitpid(pid, NULL, 0); 
  fputs("\n child terminated \n", logFile);
  fflush(logFile);
  return;
}




int main(void){
  char  logFileName[] = "parent.log";
  FILE *logFile;
  pid_t pid;
  

  logFile =fopen(logFileName, "wt");
  if (logFile == NULL){
    printf("\n P: could not open file: %s", logFileName);
  }
  
  if (fputs("\n ----- \n P: vor fork()", logFile) == 0){
    printf("\n P: could not write to file: %s", logFileName);
  } 
  fflush(logFile);

  pid = fork();
  if (pid == 0){
    childFunction();
  }
  if (pid > 0){
    parentFunction(logFile, pid);
  }
  if (pid < 0){
    printf("\n P: could not create process "); 
  }

  return 0;
}


