
#include <stdio.h>
#include <sys/types.h> 
#include <sys/wait.h>
#include <string.h>

void childFunction(){
  int i = 0; 
  int sleepVal;
  char  logFileName[] = "child.log";
  FILE *logFile;

  logFile =fopen(logFileName, "wt");
  if (logFile == NULL){
    printf("\n P: could not open file: %s", logFileName);
  }
  fputs("\n ---- \n running child function \n", logFile);
  while (i < 15){
    sleepVal = sleep(2);
    fprintf(logFile, "%3d", i);
    fflush(logFile);
    i++;
  }
  fputs("\n end of child process \n", logFile);
  exit(0);
}

void parentFunction(FILE * logFile, pid_t pid){
  int i = 0; 
  int sleepVal;
  pid_t waitVal = 0;

  fputs("\n running parent function \n", logFile);

  while (i < 20){
    sleepVal = sleep(1);
    fprintf(logFile, " %3d", i);
    fflush(logFile);
    i++;
  }
  while (waitVal == 0){ 
     fputs("\n waiting for child - checking every 2 seconds ", logFile);
     fflush(logFile);
     waitVal = waitpid(pid, NULL, WNOHANG);
     /* ggf. Kindprozess abbrechen */
     sleepVal = sleep(2);
  }  
  fputs("\n child terminated \n", logFile);
  fflush(logFile);
  return;
}

int main(void){
  char  logFileName[] = "parent.log";
  FILE *logFile;
  pid_t pid;
  

  logFile =fopen(logFileName, "wt");
  if (logFile == NULL){
    printf("\n P: could not open file: %s", logFileName);
  }
  
  if (fputs("\n ----- \n P: vor fork()", logFile) == 0){
    printf("\n P: could not write to file: %s", logFileName);
  } 
  fflush(logFile);

  pid = fork();  /* alternativ: clone() */ 
  if (pid == 0){
    childFunction();
  }
  if (pid > 0){
    parentFunction(logFile, pid);
  }
  if (pid < 0){
    printf("\n P: could not create process "); 
  }

  return;
}


