#include <errno.h>

#include "sharedMemCommon.h"

const key_t shmKey = 1928; 
const int   semKey = 1928; 
const int   shmBufCapacity = SHM_BUF_CAPACITY; 

void printSemaphoreState(int semID);

void printMsg(IPC_MSG aMsg){
    printf("\n msg from process: %d;", aMsg.fromPid);
    printf(" value: %5.2f;", aMsg.value);
    printf(" text: %s;",  aMsg.text); 
    fflush(stdout);
    return;
}
i
int getSemaphores(){
    int semId;
    int flags = 0600 | IPC_CREAT; 

    semId = semget(semKey, 3, flags);
    if (semId == -1){
	printf ("\n could not get semaphores ");
	exit(-4);
    }
    return  semId;
}

void getReadAccess(int semId){
    int retVal; 
    int semFlag = 0;  /* nicht SEM_UNDO */
    struct sembuf semCmds[3];
    printSemaphoreState(semId); 
    /* down on mutex */ 
    semCmds[0].sem_num =  0;
    semCmds[0].sem_op  = -1;
    semCmds[0].sem_flg = semFlag;

    /* increment free slots */ 
    semCmds[1].sem_num =  1;
    semCmds[1].sem_op  = +1;
    semCmds[1].sem_flg = semFlag;

    /* decrement filled slots */ 
    semCmds[2].sem_num =  2;
    semCmds[2].sem_op  = -1;
    semCmds[2].sem_flg = semFlag;

    retVal = semop(semId, semCmds, 3);
    printSemaphoreState(semId); 
    if (retVal == -1){
	printf ("\n could not get read access on semaphores ");
	printf ("error no: %d ", errno);
	exit(-6);
    }
    return;
}

void getWriteAccess(int semId){
    int retVal; 
    int semFlag = 0;  /* nicht SEM_UNDO */
    struct sembuf semCmds[3];
    printSemaphoreState(semId); 
    /* down on mutex */ 
    semCmds[0].sem_num =  0;
    semCmds[0].sem_op  = -1;
    semCmds[0].sem_flg = semFlag;

    /* decrement free slots */ 
    semCmds[1].sem_num =  1;
    semCmds[1].sem_op  = -1;
    semCmds[1].sem_flg = semFlag;

    /* increment filled slots */ 
    semCmds[2].sem_num =  2;
    semCmds[2].sem_op  = +1;
    semCmds[2].sem_flg = semFlag;
    
    retVal = semop(semId, semCmds, 3);
    printSemaphoreState(semId); 
    if (retVal == -1){
	printf ("\n could not get write access to semaphores ");
	printf ("error no: %d ", errno);
	exit(-7);
    }
    return;
}

void releaseMutex(int semId){
    int retVal; 
    struct sembuf semCmd = {0, +1, 0}; 
    retVal = semop(semId, &semCmd, 1);
    if (retVal == -1){
	printf ("\n could not releas mutex ");
	exit(-8);
    }
    printf ("  mutex released ");
    return;
}

void printSemaphoreState(int semId){
    int retVal; 
    SEM_ARG semArg;
    unsigned short  semValues[3]; 
    semArg.array = semValues; 
    retVal = semctl(semId, 0, GETALL, semArg); 
    if (retVal == -1){
	printf ("\n could not query semaphores ");
	exit(-5);
    }
    printf(" <%d, %2d, %2d> ", semValues[0], semValues[1], semValues[2]);
    fflush(stdout); 
    return;
}
