
#ifndef SHAREDMEMCOMMON
#define SHAREDMEMCOMMON

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h> 
#include <unistd.h> 
#include <stdio.h> 
#include <stdlib.h> 

extern const key_t shmKey; 
extern const int semKey; 

/* const  int size = 1024;
 */

struct ipc_msg{
    pid_t fromPid;
    float value;
    char text[20];
};
typedef struct ipc_msg IPC_MSG;

#define SHM_BUF_CAPACITY 10

extern const int shmBufCapacity; 

struct shm_buffer{
    int high;
    int low;
    IPC_MSG messages[SHM_BUF_CAPACITY];
};
typedef struct shm_buffer SHM_BUFFER;

typedef SHM_BUFFER *SHM_BUF_PTR;  

/* application must define union semun *
 * rational: obscure                   */
union semun {
    int val;
    struct semid_ds *buf;
    unsigned short  *array;
};
typedef union semun SEM_ARG;

int  getSemaphores();
void getReadAccess(int); 
void getWriteAccess(int); 
void releaseMutex(int); 

void printMsg(IPC_MSG);

/*
void getReadAccess(int mutexKey, int bufSemKey); 
void getwriteAccess(int mutexKey, int bufSemKey); 

static void locksem (int, int);
static void unlocksem (int, int);
static void waitzero (int, int);
static int safesemget (key_t, int, int);
static int safesemctl (int, int, int, union semun);
static int safesemop (int, struct sembuf *, unsigned);
*/

#endif 
