#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h> 
#include <stdio.h> 

static void locksem (int, int);
static void unlocksem (int, int);
static void waitzero (int, int);
static int safesemget (key_t, int, int);
static int safesemctl (int, int, int, union semun);
static int safesemop (int, struct sembuf *, unsigned);


int main(void){
    key_t key = 1928; 
    int size = 1024;
    int flag = 432 | IPC_CREAT | IPC_EXCL | IPC_RMID; 
    int result = 0; 
    int shMemId = 0;
 
    shMemId = shmget(key, size, flag); 
    if (shMemId ==-1){
	printf("\n could not create shared memory");
    }

    

    return 0;
}


static void locksem (int semid, int semnum) {
   struct sembuf sb;
   sb.sem_num = semnum;
   sb.sem_op = -1;
   sb.sem_flg = SEM_UNDO;
   safesemop (semid, &sb, 1);
   return;
}

static void unlocksem (int semid, int semnum) {
   struct sembuf sb;
   sb.sem_num = semnum;
   sb.sem_op = 1;
   sb.sem_flg = SEM_UNDO;
   safesemop (semid, &sb, 1);
}

static void waitzero (int semid, int semnum) {
   struct sembuf sb;
   sb.sem_num = semnum;
   sb.sem_op = 0;
   sb.sem_flg = 0;
   safesemop (semid, &sb, 1);
   return;
}

static int safesemget (key_t key, int nsems, int semflg) {
   int retval;
   retval = semget (key, nsems, semflg);
   if (retval == -1)
      printf ("Semaphor Schlssel %d, nsems %d konnte"
              " nicht erstellt werden", key, nsems);
   return retval;
}

static int safesemctl (int semid, int semnum, int cmd, union semun arg) {
   int retval;
   retval = semctl (semid, semnum, cmd, arg);
   if (retval == -1)
      printf ("Fehler: Semaphor mit ID %d, semnum %d, "
              "Kommando %d\n", semid, semnum, cmd);
   return retval;
}

static int safesemop (int semid, struct sembuf *sops, unsigned nsops) {
   int retval;
   retval = semop (semid, sops, nsops);
   if (retval == -1)
      printf ("Fehler: Semaphor mit ID %d (%d Operation)\n",
               semid, nsops);
   return retval;
}
