
#include "sharedMemCommon.h"

void readFromSharedMem(int, SHM_BUF_PTR);
void initSharedMem(SHM_BUF_PTR);
/* SHM_BUF_PTR attachSharedMem(int *, int, int); */
void initSemaphores(int); 

int main(void){
    int flag = 432 | IPC_CREAT; 
    int result = 0; 
    int shMemId = 0;
    SHM_BUF_PTR shmBuffer = NULL; 
    int semId = getSemaphores(); 
    initSemaphores(semId);

    printf("\n creating Shared Memory Segement ");
    shMemId = shmget(shmKey, sizeof(SHM_BUFFER), flag);
    if(shMemId < 0){
	printf("\n could not create shared memory");
	exit(-1);
    }
    printf("\n attaching Shared Memory Segement ");
    shmBuffer = shmat(shMemId, NULL, 0);
    if ((int)shmBuffer == -1){
	printf("\n could not attach shared memory");
	exit(-2);
    }

    initSharedMem(shmBuffer);
    readFromSharedMem(semId, shmBuffer); 

    result = shmctl(shMemId, IPC_RMID, NULL);
    if (result == -1){
	printf("\n reader could not mark shared memory for deallocating");
    }
    result = shmdt(shmBuffer);
    if (result == -1){
	printf("\n reader could not dettach shared memory");

    }

    return 0;
}

void readFromSharedMem(int semId, SHM_BUF_PTR bufferPtr){
    IPC_MSG aMsg; 
    int i;
    for(i = 0; i < 24 ; i++){
	printf("\n reader . .");
	fflush(stdout);
	getReadAccess(semId);     
	aMsg = bufferPtr->messages[bufferPtr->low];
	bufferPtr->low = (bufferPtr->low + 1) % shmBufCapacity;
	releaseMutex(semId); 

	printf(" . sleeping ");
	fflush(stdout);
	sleep(3); 
	printMsg(aMsg);
    }
    return;
}



void initSharedMem(SHM_BUF_PTR bufferPtr){
    if (bufferPtr == NULL){
	exit(-3);
    }
    bufferPtr->high = 0; 
    bufferPtr->low = 0; 
    return; 
}

void initSemaphores(int semId){
    int retVal; 
    SEM_ARG semArg;
    unsigned short  semValues[] = {1, SHM_BUF_CAPACITY, 0}; 
    semArg.array = semValues; 
    retVal = semctl(semId, 0, SETALL, semArg); 
    if (retVal == -1){
	printf ("\n could not initialize semaphores ");
	exit(-5);
    }
    return;
}



