
#include "sharedMemCommon.h" 
#include <string.h> 


void writeToSharedMem(int, SHM_BUF_PTR);
SHM_BUF_PTR attachSharedMem(int *, int, int); 

int main(void){
    int result = 0; 
    int shMemId = 0;
    SHM_BUF_PTR shmBuffer = NULL;
    int semId = getSemaphores(); 
 

    shmBuffer  = attachSharedMem(&shMemId, shmKey, sizeof(SHM_BUFFER));
    if (shMemId == -1){
        printf("\n could not attach shared memory");
        exit(-1);
    }

    writeToSharedMem(semId, shmBuffer); 

    result = shmdt(shmBuffer);
    if (result == -1){
       printf("\n writer could not dettach shared memory");

    }
    return 0;
}

void writeToSharedMem(int semId, SHM_BUF_PTR bufferPtr){
    int i; 
    pid_t myPid = getpid(); 
    int msgId; 

    for(i = 0; i < 12 ; i++){ 
	printf("\n writer . ."); 
	fflush(stdout);
        getWriteAccess(semId); 
        msgId = bufferPtr->high;

	bufferPtr->messages[msgId].fromPid = myPid;
        bufferPtr->messages[msgId].value   = (float) (myPid%(19+i)) / 3; 
	strncpy(bufferPtr->messages[msgId].text, "shared mem msg:  ", 19);
	bufferPtr->messages[msgId].text[17] = i%10 + '0';
	bufferPtr->messages[msgId].text[19] = 0;

        bufferPtr->high = (bufferPtr->high + 1) % shmBufCapacity;
        releaseMutex(semId); 

	printf(". sleeping");
	fflush(stdout);
        sleep(2); 
	printf(" . done %d ", i); 
        fflush(stdout);
    } 
    return; 
}


SHM_BUF_PTR attachSharedMem(int *shMemId, int key, int size){
    SHM_BUF_PTR shmBuffer = NULL; 
    int flag = 0; 

    *shMemId = shmget(key, size, flag); 
    if (*shMemId == -1){
        printf("\n could not get access to shared memory");
        exit(-1);
    }
    shmBuffer = shmat(*shMemId, NULL, 0);
    if ((int) shmBuffer == -1){
       printf("\n could not attach shared memory");
       exit(-2);
    }
    return shmBuffer; 
}


